/* ******************************************************************

   author     : puehringer edgar

   compiler   : javac (jdk 1.1.3)            

   class      : CheckboxMenuItemGroup
   date       : 15.01.98
   description: groups CheckboxMenuItems together so that only one
                can be selected

*********************************************************************/

/* ******************************************************************
   import statements
*********************************************************************/

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/* ******************************************************************
   top level class declaration
*********************************************************************/

public class CheckboxMenuItemGroup implements ItemListener {

  // class variable declarations

  // instance variable declarations
  private Vector vector;
  private int index;

  // constructors
  public CheckboxMenuItemGroup() {
    vector = new Vector();
    index  = -1;
  } // end constructor CheckboxMenuItemGroup

  // methods
  public synchronized void add(CheckboxMenuItem item) {
    vector.addElement(item);
    if (item.getState()) {
      if (index >= 0) ((CheckboxMenuItem)vector.elementAt(index)).setState(false);
      index = vector.size()-1;
    } // end if
    if (index < 0) {
      index = vector.size()-1;
      ((CheckboxMenuItem)vector.elementAt(index)).setState(true);
    } // end if
    item.addItemListener(this);
  } // end add

  public CheckboxMenuItem getSelectedCheckboxMenuItem() {
    if (index < 0) return null;
      else return (CheckboxMenuItem)vector.elementAt(index);
  } // end getSelectedCheckboxMenuItem

  public synchronized void setSelectedCheckboxMenuItem(CheckboxMenuItem item) {
    int i = vector.indexOf(item);
    if (i >= 0) {
      ((CheckboxMenuItem)vector.elementAt(index)).setState(false);
      ((CheckboxMenuItem)vector.elementAt(i)).setState(true);
      index = i;
    } // end if
  } // end setSelectedCheckboxMenuItem

  public void itemStateChanged(ItemEvent e) {
    ItemSelectable item = e.getItemSelectable();
    int n      = vector.size();
    int i      = 0;

    while (i < n) {
      if (item.equals(vector.elementAt(i))) n = 0;
        else i++;
    } // end while
    ((CheckboxMenuItem)vector.elementAt(index)).setState(false);
    ((CheckboxMenuItem)vector.elementAt(i)).setState(true);
    index = i;
  } // end itemStateChanged

} // end CheckboxMenuItemGroup

/* ******************************************************************
   end of file
*********************************************************************/
